Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationInstanceProvider.cs	(revision 7850)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ClassificationInstanceProvider.cs	(revision 7851)
@@ -23,5 +23,4 @@
 using System.Collections;
 using System.Collections.Generic;
-using System.Globalization;
 using System.IO;
 using System.Linq;
@@ -32,25 +31,7 @@
   public abstract class ClassificationInstanceProvider : IProblemInstanceProvider<IClassificationProblemData> {
     public IClassificationProblemData LoadData(string path) {
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormat;
-      char separator;
-      TableFileParser.DetermineFileFormat(new FileStream(path, FileMode.Open), out numberFormat, out dateFormat, out separator);
-
-      IClassificationProblemData claData = LoadData(new FileStream(path, FileMode.Open), numberFormat, dateFormat, separator);
-      int pos = path.LastIndexOf('\\');
-      if (pos < 0)
-        claData.Name = path;
-      else {
-        pos++;
-        claData.Name = path.Substring(pos, path.Length - pos);
-      }
-
-      return claData;
-    }
-
-    protected IClassificationProblemData LoadData(Stream stream, NumberFormatInfo numberFormat, DateTimeFormatInfo dateFormat, char separator) {
       TableFileParser csvFileParser = new TableFileParser();
 
-      csvFileParser.Parse(stream, numberFormat, dateFormat, separator);
+      csvFileParser.Parse(path);
 
       Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
@@ -65,4 +46,12 @@
       claData.TestPartition.Start = trainingPartEnd;
       claData.TestPartition.End = csvFileParser.Rows;
+      int pos = path.LastIndexOf('\\');
+      if (pos < 0)
+        claData.Name = path;
+      else {
+        pos++;
+        claData.Name = path.Substring(pos, path.Length - pos);
+      }
+
       return claData;
     }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationInstanceProvider.cs	(revision 7850)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/ResourceClassificationInstanceProvider.cs	(revision 7851)
@@ -64,8 +64,21 @@
         }
 
-        IClassificationProblemData claData;
+        TableFileParser csvFileParser = new TableFileParser();
         using (Stream stream = instancesZipFile.GetInputStream(entry)) {
-          claData = LoadData(stream, numberFormat, dateFormat, separator);
+          csvFileParser.Parse(stream, numberFormat, dateFormat, separator);
         }
+
+        Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
+        string targetVar = csvFileParser.VariableNames.Last();
+        IEnumerable<string> allowedInputVars = csvFileParser.VariableNames.Where(x => !x.Equals(targetVar));
+
+        ClassificationProblemData claData = new ClassificationProblemData(dataset, allowedInputVars, targetVar);
+
+        int trainingPartEnd = csvFileParser.Rows * 2 / 3;
+        claData.TrainingPartition.Start = 0;
+        claData.TrainingPartition.End = trainingPartEnd;
+        claData.TestPartition.Start = trainingPartEnd;
+        claData.TestPartition.End = csvFileParser.Rows;
+
         claData.Name = descriptor.Name;
         claData.Description = descriptor.Description;
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RegressionInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RegressionInstanceProvider.cs	(revision 7850)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RegressionInstanceProvider.cs	(revision 7851)
@@ -23,5 +23,4 @@
 using System.Collections;
 using System.Collections.Generic;
-using System.Globalization;
 using System.IO;
 using System.Linq;
@@ -33,10 +32,18 @@
 
     public IRegressionProblemData LoadData(string path) {
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormat;
-      char separator;
-      TableFileParser.DetermineFileFormat(path, out numberFormat, out dateFormat, out separator);
+      TableFileParser csvFileParser = new TableFileParser();
+      csvFileParser.Parse(path);
 
-      IRegressionProblemData regData = LoadData(new FileStream(path, FileMode.Open), numberFormat, dateFormat, separator);
+      Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
+      string targetVar = csvFileParser.VariableNames.Last();
+      IEnumerable<string> allowedInputVars = csvFileParser.VariableNames.Where(x => !x.Equals(targetVar));
+
+      IRegressionProblemData regData = new RegressionProblemData(dataset, allowedInputVars, targetVar);
+
+      int trainingPartEnd = csvFileParser.Rows * 2 / 3;
+      regData.TrainingPartition.Start = 0;
+      regData.TrainingPartition.End = trainingPartEnd;
+      regData.TestPartition.Start = trainingPartEnd;
+      regData.TestPartition.End = csvFileParser.Rows;
 
       int pos = path.LastIndexOf('\\');
@@ -47,24 +54,4 @@
         regData.Name = path.Substring(pos, path.Length - pos);
       }
-      return regData;
-    }
-
-    protected IRegressionProblemData LoadData(Stream stream, NumberFormatInfo numberFormat, DateTimeFormatInfo dateFormat, char separator) {
-      TableFileParser csvFileParser = new TableFileParser();
-
-      csvFileParser.Parse(stream, numberFormat, dateFormat, separator);
-
-      Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
-      string targetVar = csvFileParser.VariableNames.Last();
-      IEnumerable<string> allowedInputVars = csvFileParser.VariableNames.Where(x => !x.Equals(targetVar));
-
-      RegressionProblemData regData = new RegressionProblemData(dataset, allowedInputVars, targetVar);
-
-      int trainingPartEnd = csvFileParser.Rows * 2 / 3;
-      regData.TrainingPartition.Start = 0;
-      regData.TrainingPartition.End = trainingPartEnd;
-      regData.TestPartition.Start = trainingPartEnd;
-      regData.TestPartition.End = csvFileParser.Rows;
-
       return regData;
     }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionInstanceProvider.cs	(revision 7850)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionInstanceProvider.cs	(revision 7851)
@@ -64,8 +64,20 @@
         }
 
-        IRegressionProblemData regData;
+        TableFileParser csvFileParser = new TableFileParser();
         using (Stream stream = instancesZipFile.GetInputStream(entry)) {
-          regData = LoadData(stream, numberFormat, dateFormat, separator);
+          csvFileParser.Parse(stream, numberFormat, dateFormat, separator);
         }
+
+        Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
+        string targetVar = csvFileParser.VariableNames.Last();
+        IEnumerable<string> allowedInputVars = csvFileParser.VariableNames.Where(x => !x.Equals(targetVar));
+
+        IRegressionProblemData regData = new RegressionProblemData(dataset, allowedInputVars, targetVar);
+
+        int trainingPartEnd = csvFileParser.Rows * 2 / 3;
+        regData.TrainingPartition.Start = 0;
+        regData.TrainingPartition.End = trainingPartEnd;
+        regData.TestPartition.Start = trainingPartEnd;
+        regData.TestPartition.End = csvFileParser.Rows;
 
         regData.Name = descriptor.Name;
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/TableFileParser.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/TableFileParser.cs	(revision 7850)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/TableFileParser.cs	(revision 7851)
@@ -75,8 +75,45 @@
     }
 
+    /// <summary>
+    /// Parses a file and determines the format first
+    /// </summary>
+    /// <param name="fileName">file which is parsed</param>
+    public void Parse(string fileName) {
+      NumberFormatInfo numberFormat;
+      DateTimeFormatInfo dateTimeFormatInfo;
+      char separator;
+      DetermineFileFormat(new FileStream(fileName, FileMode.Open), out numberFormat, out dateTimeFormatInfo, out separator);
+      Parse(new FileStream(fileName, FileMode.Open), numberFormat, dateTimeFormatInfo, separator);
+    }
+
+    /// <summary>
+    /// Parses a file with the given formats
+    /// </summary>
+    /// <param name="fileName">file which is parsed</param>
+    /// <param name="numberFormat">Format of numbers</param>
+    /// <param name="dateTimeFormatInfo">Format of datetime</param>
+    /// <param name="separator">defines the separator</param>
     public void Parse(string fileName, NumberFormatInfo numberFormat, DateTimeFormatInfo dateTimeFormatInfo, char separator) {
       Parse(new FileStream(fileName, FileMode.Open), numberFormat, dateTimeFormatInfo, separator);
     }
 
+    /// <summary>
+    /// Takes a Stream and parses it with default format. NumberFormatInfo.InvariantInfo, DateTimeFormatInfo.InvariantInfo and separator = ','
+    /// </summary>
+    /// <param name="stream">stream which is parsed</param>
+    public void Parse(Stream stream) {
+      NumberFormatInfo numberFormat = NumberFormatInfo.InvariantInfo;
+      DateTimeFormatInfo dateTimeFormatInfo = DateTimeFormatInfo.InvariantInfo;
+      char separator = ',';
+      Parse(stream, numberFormat, dateTimeFormatInfo, separator);
+    }
+
+    /// <summary>
+    /// Parses a stream with the given formats.
+    /// </summary>
+    /// <param name="stream">Stream which is parsed</param>    
+    /// <param name="numberFormat">Format of numbers</param>
+    /// <param name="dateTimeFormatInfo">Format of datetime</param>
+    /// <param name="separator">defines the separator</param>
     public void Parse(Stream stream, NumberFormatInfo numberFormat, DateTimeFormatInfo dateTimeFormatInfo, char separator) {
       using (StreamReader reader = new StreamReader(stream)) {
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/TableFileParserTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/TableFileParserTest.cs	(revision 7850)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/TableFileParserTest.cs	(revision 7851)
@@ -21,5 +21,4 @@
 
 using System;
-using System.Globalization;
 using System.IO;
 using HeuristicLab.Problems.Instances.DataAnalysis;
@@ -34,7 +33,4 @@
     public void ParseCSV() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0.00, 0.00, 0.00, 3.14
@@ -46,6 +42,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -59,7 +54,4 @@
     public void ParseCSVWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01, x02, x03, x04
@@ -72,6 +64,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -86,7 +77,4 @@
     public void ParseGermanCSV() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0,00; 0,00; 0,00; 3,14
@@ -98,6 +86,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -112,7 +99,4 @@
     public void ParseGermanCSVWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01; x02; x03; x04
@@ -125,6 +109,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -139,7 +122,4 @@
     public void ParseGermanCSVWithoutCommas() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0; 0; 0; 3
@@ -151,6 +131,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -164,7 +143,4 @@
     public void ParseGermanCSVWithoutCommasWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01; x02; x03; x04
@@ -177,6 +153,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -191,7 +166,4 @@
     public void ParseEnglishCSVWithoutCommas() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0, 0, 0, 3
@@ -203,6 +175,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -217,7 +188,4 @@
     public void ParseEnglishCSVWithoutCommasWithoutSpace() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0,0,0,3
@@ -229,6 +197,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -243,7 +210,4 @@
     public void ParseEnglishCSVWithoutCommasWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01, x02, x03, x04
@@ -256,6 +220,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -270,7 +233,4 @@
     public void ParseEnglishCSVWithoutCommasWithoutSpacesWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01,x02,x03,x04
@@ -283,6 +243,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -298,7 +257,4 @@
     public void ParseGermanTabSeparated() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       "0,00\t 0,00\t 0,00\t 3,14" + Environment.NewLine +
@@ -310,6 +266,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -324,7 +279,4 @@
     public void ParseGermanTabSeparatedWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       "x01\t x02\t x03\t x04" + Environment.NewLine +
@@ -337,6 +289,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -351,7 +302,4 @@
     public void ParseEnglishTabSeparated() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       "0.00\t 0.00\t 0.00\t 3.14" + Environment.NewLine +
@@ -363,6 +311,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -376,7 +323,4 @@
     public void ParseEnglishTabSeparatedWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       "x01\t x02\t x03\t x04" + Environment.NewLine +
@@ -389,6 +333,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -403,7 +346,4 @@
     public void ParseTabSeparatedWithoutCommas() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       "0\t 0\t 0\t 3" + Environment.NewLine +
@@ -415,6 +355,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -428,7 +367,4 @@
     public void ParseTabSeparatedWithoutCommasWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       "x01\t x02\t x03\t x04" + Environment.NewLine +
@@ -441,6 +377,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -455,7 +390,4 @@
     public void ParseWithEmtpyLines() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       "x01\t x02\t x03\t x04" + Environment.NewLine +
@@ -468,6 +400,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(4, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -481,7 +412,4 @@
     public void ParseGermanSpaceSeparated() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0,00 0,00 0,00 3,14
@@ -493,6 +421,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -506,7 +433,4 @@
     public void ParseGermanSpaceSeparatedWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01 x02 x03 x04
@@ -519,6 +443,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -533,7 +456,4 @@
     public void ParseEnglishSpaceSeparated() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0.00 0.00 0.00 3.14
@@ -545,6 +465,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -558,7 +477,4 @@
     public void ParseEnglishSpaceSeparatedWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01 x02 x03 x04
@@ -571,6 +487,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -585,7 +500,4 @@
     public void ParseSpaceSeparatedWithoutCommas() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"0 0 0 3
@@ -597,6 +509,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -610,7 +521,4 @@
     public void ParseSpaceSeparatedWithoutCommasWithNames() {
       string tempFileName = Path.GetTempFileName();
-      NumberFormatInfo numberFormat;
-      DateTimeFormatInfo dateFormatInfo;
-      char separator;
       WriteToFile(tempFileName,
       @"x01 x02 x03 x04
@@ -623,6 +531,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        TableFileParser.DetermineFileFormat(tempFileName, out numberFormat, out dateFormatInfo, out separator);
-        parser.Parse(tempFileName, numberFormat, dateFormatInfo, separator);
+        parser.Parse(tempFileName);
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);